-module(gluple@transform).
-compile([no_auto_import, nowarn_unused_vars, nowarn_unused_function, nowarn_nomatch]).

-export([replace_last1/2, replace_last2/2, replace_last3/2, replace_last4/2, replace_last5/2, replace_last6/2, replace_last7/2, replace_last8/2, replace_last9/2, with_replace_last1/2, with_replace_last2/2, with_replace_last3/2, with_replace_last4/2, with_replace_last5/2, with_replace_last6/2, with_replace_last7/2, with_replace_last8/2, with_replace_last9/2]).

-spec replace_last1({any()}, JQW) -> {JQW}.
replace_last1(_, Data) ->
    {Data}.

-spec replace_last2({JQX, any()}, JQZ) -> {JQX, JQZ}.
replace_last2(Tuple, Data) ->
    {erlang:element(1, Tuple), Data}.

-spec replace_last3({JRA, JRB, any()}, JRD) -> {JRA, JRB, JRD}.
replace_last3(Tuple, Data) ->
    {erlang:element(1, Tuple), erlang:element(2, Tuple), Data}.

-spec replace_last4({JRE, JRF, JRG, any()}, JRI) -> {JRE, JRF, JRG, JRI}.
replace_last4(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        Data}.

-spec replace_last5({JRJ, JRK, JRL, JRM, any()}, JRO) -> {JRJ,
    JRK,
    JRL,
    JRM,
    JRO}.
replace_last5(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        Data}.

-spec replace_last6({JRP, JRQ, JRR, JRS, JRT, any()}, JRV) -> {JRP,
    JRQ,
    JRR,
    JRS,
    JRT,
    JRV}.
replace_last6(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        Data}.

-spec replace_last7({JRW, JRX, JRY, JRZ, JSA, JSB, any()}, JSD) -> {JRW,
    JRX,
    JRY,
    JRZ,
    JSA,
    JSB,
    JSD}.
replace_last7(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        Data}.

-spec replace_last8({JSE, JSF, JSG, JSH, JSI, JSJ, JSK, any()}, JSM) -> {JSE,
    JSF,
    JSG,
    JSH,
    JSI,
    JSJ,
    JSK,
    JSM}.
replace_last8(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        Data}.

-spec replace_last9({JSN, JSO, JSP, JSQ, JSR, JSS, JST, JSU, any()}, JSW) -> {JSN,
    JSO,
    JSP,
    JSQ,
    JSR,
    JSS,
    JST,
    JSU,
    JSW}.
replace_last9(Tuple, Data) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        erlang:element(8, Tuple),
        Data}.

-spec with_replace_last1({JSX}, fun((JSX) -> JSY)) -> {JSY}.
with_replace_last1(Tuple, Cb) ->
    {Cb(erlang:element(1, Tuple))}.

-spec with_replace_last2({JSZ, JTA}, fun((JSZ, JTA) -> JTB)) -> {JSZ, JTB}.
with_replace_last2(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        Cb(erlang:element(1, Tuple), erlang:element(2, Tuple))}.

-spec with_replace_last3({JTC, JTD, JTE}, fun((JTC, JTD, JTE) -> JTF)) -> {JTC,
    JTD,
    JTF}.
with_replace_last3(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple)
        )}.

-spec with_replace_last4({JTG, JTH, JTI, JTJ}, fun((JTG, JTH, JTI, JTJ) -> JTK)) -> {JTG,
    JTH,
    JTI,
    JTK}.
with_replace_last4(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple)
        )}.

-spec with_replace_last5(
    {JTL, JTM, JTN, JTO, JTP},
    fun((JTL, JTM, JTN, JTO, JTP) -> JTQ)
) -> {JTL, JTM, JTN, JTO, JTQ}.
with_replace_last5(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple)
        )}.

-spec with_replace_last6(
    {JTR, JTS, JTT, JTU, JTV, JTW},
    fun((JTR, JTS, JTT, JTU, JTV, JTW) -> JTX)
) -> {JTR, JTS, JTT, JTU, JTV, JTX}.
with_replace_last6(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple)
        )}.

-spec with_replace_last7(
    {JTY, JTZ, JUA, JUB, JUC, JUD, JUE},
    fun((JTY, JTZ, JUA, JUB, JUC, JUD, JUE) -> JUF)
) -> {JTY, JTZ, JUA, JUB, JUC, JUD, JUF}.
with_replace_last7(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple),
            erlang:element(7, Tuple)
        )}.

-spec with_replace_last8(
    {JUG, JUH, JUI, JUJ, JUK, JUL, JUM, JUN},
    fun((JUG, JUH, JUI, JUJ, JUK, JUL, JUM, JUN) -> JUO)
) -> {JUG, JUH, JUI, JUJ, JUK, JUL, JUM, JUO}.
with_replace_last8(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple),
            erlang:element(7, Tuple),
            erlang:element(8, Tuple)
        )}.

-spec with_replace_last9(
    {JUP, JUQ, JUR, JUS, JUT, JUU, JUV, JUW, JUX},
    fun((JUP, JUQ, JUR, JUS, JUT, JUU, JUV, JUW, JUX) -> JUY)
) -> {JUP, JUQ, JUR, JUS, JUT, JUU, JUV, JUW, JUY}.
with_replace_last9(Tuple, Cb) ->
    {erlang:element(1, Tuple),
        erlang:element(2, Tuple),
        erlang:element(3, Tuple),
        erlang:element(4, Tuple),
        erlang:element(5, Tuple),
        erlang:element(6, Tuple),
        erlang:element(7, Tuple),
        erlang:element(8, Tuple),
        Cb(
            erlang:element(1, Tuple),
            erlang:element(2, Tuple),
            erlang:element(3, Tuple),
            erlang:element(4, Tuple),
            erlang:element(5, Tuple),
            erlang:element(6, Tuple),
            erlang:element(7, Tuple),
            erlang:element(8, Tuple),
            erlang:element(9, Tuple)
        )}.
